/*
 * libxml-dtc provides an XML framework creation facilities
 * Copyright (C) 2003-2004 Mike Hommey <mh@glandium.org>
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

#ifndef __SITEMAP_H__
#define __SITEMAP_H__

typedef struct _xml_dtc_sitemap xml_dtc_sitemap;

#include <components.h>
#include <request.h>
#include <libxml/tree.h>

#define XML_DTC_SITEMAP_NAMESPACE "http://apache.org/cocoon/sitemap/1.0"
#define XML_DTC_SITEMAP_ROOT_NODE "sitemap"

struct _xml_dtc_sitemap {
  xml_dtc_resource *resource;
  xml_dtc_hash *hash;
  xml_dtc_list *pipelines;
  char *base_dir;
};

int xml_dtc_sitemap_add(xml_dtc_sitemap *sitemap, xml_dtc_component *component);

xml_dtc_component *xml_dtc_sitemap_get(xml_dtc_sitemap *sitemap, char *type, char *name);

xml_dtc_hash *xml_dtc_sitemap_get_all_type(xml_dtc_sitemap *sitemap, char *type);

int xml_dtc_sitemap_set_preferred_by_key(xml_dtc_sitemap *sitemap, char *type, char *name);

xml_dtc_sitemap *xml_dtc_sitemap_new(const xml_dtc_resource *resource);

xml_dtc_sitemap *xml_dtc_sitemap_new_from_file(xml_dtc_resource *resource, char *file);

int xml_dtc_sitemap_request(xml_dtc_sitemap *sitemap, xml_dtc_request *request);

int xml_dtc_sitemap_resolve_relative_path(xml_dtc_sitemap *sitemap, char **path);

int xml_dtc_sitemap_free(xml_dtc_sitemap *sitemap);

xml_dtc_list *xml_dtc_sitemap_get_pipeline(xml_dtc_sitemap *sitemap, xmlNodePtr node);

#endif /* __SITEMAP_H__ */
