/*
 * libxml-dtc provides an XML framework creation facilities
 * Copyright (C) 2003-2004 Mike Hommey <mh@glandium.org>
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

#ifndef __XML_DTC_H__
#define __XML_DTC_H__

extern struct _xml_dtc xml_dtc;

typedef struct _xml_dtc_handler xml_dtc_handler;

#include <resource.h>
#include <hash.h>
#include <list.h>
#include <sitemap.h>
#include <request.h>
#include <components.h>
#include <libxml/tree.h>

typedef xml_dtc_component * (*xml_dtc_handler_callback) (xml_dtc_handler *handler, xml_dtc_hash *handlers, xml_dtc_sitemap *sitemap, xmlNodePtr node);

typedef int (*xml_dtc_runner_callback) (xml_dtc_request *request);

struct _xml_dtc_handler {
  void *_private;
};

struct _xml_dtc {
  xml_dtc_resource *resource;
  xml_dtc_list *hooks;
  xml_dtc_hash *modules;
  xml_dtc_hash *components;
  xml_dtc_hash *callers;
};

int xml_dtc_init_modules();

int xml_dtc_init(const xml_dtc_resource *resource);

int xml_dtc_cleanup();

typedef int (*xml_dtc_hook) (xml_dtc_caller *caller, xml_dtc_request *request);

int xml_dtc_register_hook(xml_dtc_hook callback);

#endif /* __XML_DTC_H__ */
